org.python.core

## Class PyReflectedFunction

- java.lang.Object
- - org.python.core.PyObject
  - - org.python.core.PyReflectedFunction

All Implemented Interfaces:
  java.io.Serializable, Traverseproc

Direct Known Subclasses:
  PyReflectedConstructor

    public class PyReflectedFunction
    extends PyObject
    implements Traverseproc

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.python.core.PyObject

`PyObject.ConversionException`

### Field Summary

Fields
`PyObject` `__doc__`
`PyObject` `__module__`
`java.lang.String` `__name__`
`ReflectedArgs[]` `argslist`
`int` `nargs`

### Fields inherited from class org.python.core.PyObject

`gcMonitorGlobal, TYPE`

### Constructor Summary

Constructors
Constructor and Description
`PyReflectedFunction(java.lang.reflect.Method... methods)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`PyObject` `__call__(PyObject[] args, java.lang.String[] keywords)` The basic method to override when implementing a callable object.
`PyObject` `__call__(PyObject self, PyObject[] args, java.lang.String[] keywords)` A variant of the __call__ method with one extra initial argument.
`PyObject` `_doget(PyObject container)`
`PyObject` `_doget(PyObject container, PyObject wherefound)`
`void` `addMethod(java.lang.reflect.Method m)`
`PyReflectedFunction` `copy()`
`boolean` `handles(java.lang.reflect.Method method)`
`static boolean` `isPackagedProtected(java.lang.Class<?> c)`
`void` `printArgs()`
`boolean` `refersDirectlyTo(PyObject ob)` Optional operation.
`java.lang.String` `toString()`
`int` `traverse(Visitproc visit, java.lang.Object arg)` Traverses all directly contained `PyObject`s.

### Methods inherited from class org.python.core.PyObject

`__abs__, __add__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __cmp__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delattr__, __delete__, __delitem__, __delitem__, __delslice__, __delslice__, __dir__, __div__, __divmod__, __ensure_finalizer__, __eq__, __findattr__, __findattr__, __findattr_ex__, __finditem__, __finditem__, __finditem__, __float__, __floordiv__, __format__, __ge__, __get__, __getattr__, __getattr__, __getitem__, __getitem__, __getnewargs__, __getslice__, __getslice__, __gt__, __hash__, __hex__, __iadd__, __iand__, __idiv__, __idivmod__, __ifloordiv__, __ilshift__, __imod__, __imul__, __index__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __iter__, __iternext__, __itruediv__, __ixor__, __le__, __len__, __long__, __lshift__, __lt__, __mod__, __mul__, __ne__, __neg__, __nonzero__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __radd__, __rand__, __rdiv__, __rdivmod__, __reduce__, __reduce_ex__, __reduce_ex__, __repr__, __rfloordiv__, __rlshift__, __rmod__, __rmul__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rtruediv__, __rxor__, __set__, __setattr__, __setattr__, __setitem__, __setitem__, __setitem__, __setslice__, __setslice__, __str__, __sub__, __tojava__, __truediv__, __trunc__, __unicode__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _doset, _eq, _floordiv, _ge, _gt, _iadd, _iand, _idiv, _idivmod, _ifloordiv, _ilshift, _imod, _imul, _in, _ior, _ipow, _irshift, _is, _isnot, _isub, _itruediv, _ixor, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _truediv, _xor, asDouble, asIndex, asIndex, asInt, asInt, asIterable, asLong, asLong, asName, asName, asString, asString, asStringOrNull, asStringOrNull, bit_length, conjugate, delDict, delType, dispatch__init__, equals, fastGetClass, fastGetDict, getDict, getType, hashCode, implementsDescrDelete, implementsDescrGet, implementsDescrSet, invoke, invoke, invoke, invoke, invoke, invoke, isCallable, isDataDescr, isIndex, isInteger, isMappingType, isNumberType, isSequenceType, noAttributeError, object___subclasshook__, readonlyAttributeError, setDict, setType`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### __name__

    public java.lang.String __name__

#### __doc__

    public PyObject __doc__

#### __module__

    public PyObject __module__

#### argslist

    public ReflectedArgs[] argslist

#### nargs

    public int nargs

### Constructor Detail

#### PyReflectedFunction

    public PyReflectedFunction(java.lang.reflect.Method... methods)

### Method Detail

#### _doget

    public PyObject _doget(PyObject container)

Overrides:
  `_doget` in class `PyObject`

#### _doget

    public PyObject _doget(PyObject container,
                           PyObject wherefound)

Overrides:
  `_doget` in class `PyObject`

#### copy

    public PyReflectedFunction copy()

#### handles

    public boolean handles(java.lang.reflect.Method method)

#### addMethod

    public void addMethod(java.lang.reflect.Method m)

#### isPackagedProtected

    public static boolean isPackagedProtected(java.lang.Class<?> c)

#### __call__

    public PyObject __call__(PyObject self,
                             PyObject[] args,
                             java.lang.String[] keywords)

Description copied from class: `PyObject`
A variant of the __call__ method with one extra initial argument. This variant is used to allow method invocations to be performed efficiently. The default behavior is to invoke `__call__(args, keywords)` with the appropriate arguments. The only reason to override this function would be for improved performance.

Overrides:
  `__call__` in class `PyObject`
Parameters:
  `self` - the first argument to the function.
  `args` - the last arguments to the function (including keyword arguments).
  `keywords` - the keywords used for all keyword arguments.

#### __call__

    public PyObject __call__(PyObject[] args,
                             java.lang.String[] keywords)

Description copied from class: `PyObject`
The basic method to override when implementing a callable object. The first len(args)-len(keywords) members of args[] are plain arguments. The last len(keywords) arguments are the values of the keyword arguments.

Overrides:
  `__call__` in class `PyObject`
Parameters:
  `args` - all arguments to the function (including keyword arguments).
  `keywords` - the keywords used for all keyword arguments.

#### printArgs

    public void printArgs()

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `PyObject`

#### traverse

    public int traverse(Visitproc visit,
                        java.lang.Object arg)

Description copied from interface: `Traverseproc`
Traverses all directly contained `PyObject`s. Like in CPython, `arg` must be passed unmodified to `visit` as its second parameter. If `Visitproc.visit(PyObject, Object)` returns nonzero, this return value must be returned immediately by traverse. `Visitproc.visit(PyObject, Object)` must not be called with a `null` PyObject-argument.

Specified by:
  `traverse` in interface `Traverseproc`

#### refersDirectlyTo

    public boolean refersDirectlyTo(PyObject ob)

Description copied from interface: `Traverseproc`
Optional operation. Should only be implemented if it is more efficient than calling `Traverseproc.traverse(Visitproc, Object)` with a visitproc that just watches out for `ob`. Must return `false` if `ob` is `null`.

Specified by:
  `refersDirectlyTo` in interface `Traverseproc`